<script>
import Vue from 'vue';
import SlpCloseModal from '~/static/nuxt-images/video-carousels/close-modal-icon.vue';

export default Vue.extend({
  name: 'VideoModal',
  components: {
    SlpCloseModal,
  },
  props: {
    lightBackground: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  mounted() {
    // Done to prevent scrolling on the content behind the modal
    document.querySelector('body').classList.add('noScroll');
  },
  destroyed() {
    document.querySelector('body').classList.remove('noScroll');
  },
  methods: {
    close() {
      this.$emit('close');
    },
  },
});
</script>

<template>
  <div
    :class="[
      lightBackground
        ? 'modal__backdrop modal__backdrop--light'
        : 'modal__backdrop',
    ]"
    @click.self="close"
  >
    <div class="modal">
      <header class="modal__header">
        <slot name="header"></slot>
        <button type="button" class="btn btn__close" @click="close">
          <SlpCloseModal />
        </button>
      </header>
      <section class="modal__body">
        <slot name="body"></slot>
      </section>
      <footer class="modal__footer">
        <slot name="footer"></slot>
      </footer>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.modal {
  background: transparent;
  display: flex;
  flex-direction: column;
  margin-top: $spacing-160;
  &__backdrop {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: rgba($color-surface-700, 0.85);
    display: flex;
    justify-content: center;
    align-items: flex-start;
    z-index: 1040;
    &--light {
      background-color: #d1d0d3c4;
    }
  }

  &__header {
    position: relative;
    justify-content: space-between;
    background-color: transparent;
  }
  &__header,
  &__footer {
    padding: $spacing-16;
    display: flex;
  }
  &__body {
    position: relative;
    padding: $spacing-8;
    iframe,
    lite-vimeo {
      border-radius: $border-radius-4;
      border: none;
      width: 330px;
      height: 200px;
      @media (min-width: $breakpoint-md) {
        width: 700px;
        height: 390px;
      }
      @media (min-width: $breakpoint-lg) {
        width: 920px;
        height: 516px;
      }
    }
  }
}
.btn {
  &__close {
    position: absolute;
    right: -$spacing-8;
    width: 45px;
    height: 45px;
    top: 0;
    border: none;
    border-radius: 50%;
    cursor: pointer;
    @media (min-width: $breakpoint-lg) {
      right: -$spacing-24;
    }

    svg {
      width: 100%;
      height: 100%;
    }
  }
}
</style>
